<template>
  <rui-collapsible-list-item>
    <template v-if="editable" #actions>
      <rui-button icon="pencil" :title="$t('generic.edit')" @click="showEditResourceInteractionForm(resourceInteraction)" />
    </template>

    <template #caption>{{ otherGroup.name }}</template>

    <div class="-text--small">
      <p class="-mbd">
        <strong>{{ $t('js.resource_interactions.list_entry.interaction_type') }}</strong>
        {{ $t(`activerecord.attributes.resource_interaction/nature.${resourceInteraction.nature}`) }}
      </p>

      <div class="-flex -gap -justify-content-center">
        <rui-button :variant="natureCSS(resourceInteraction.nature, 0)"
                    :caption="resourceInteraction.subject.name"
                    size="small"
                    :to="{name: 'resourceInteractionsGroups', params: {resourceInteractionsGroupId: resourceInteraction.subject.id}}"
                    text />
        <rui-icon name="arrows-left-right" />
        <rui-button :variant="natureCSS(resourceInteraction.nature, 1)"
                    :caption="resourceInteraction.target.name"
                    size="small"
                    :to="{name: 'resourceInteractionsGroups', params: {resourceInteractionsGroupId: resourceInteraction.target.id}}"
                    text />
      </div>
    </div>

    <template v-if="resourceInteraction.notes">
      <hr>
      <p class="-text--small">{{ resourceInteraction.notes }}</p>
      <hr>
    </template>

    <div v-if="resourceInteraction.sources" class="-text--small">
      <strong>{{ $t('activerecord.attributes.resource_interaction.sources') }}</strong>
      <ul class="-pre-wrap">
        <li v-for="source in resourceInteraction.sources.split('\n')" :key="source">{{ source }}</li>
      </ul>
    </div>
  </rui-collapsible-list-item>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'
import RuiCollapsibleListItem from '@experiments-labs/rise_ui/src/components/ListItem/CollapsibleListItem.vue'

import ResourceInteraction, { NATURES } from '../../../../classes/models/ResourceInteraction'
import ResourceInteractionsGroup from '../../../../classes/models/ResourceInteractionsGroup'

export default {
  name: 'GpaResourceInteractionsListEntry',
  components: { RuiCollapsibleListItem, RuiIcon, RuiButton },
  props: {
    resourceInteraction: { required: true, type: ResourceInteraction },
    forGroup: { required: true, type: ResourceInteractionsGroup },
    editable: { required: false, type: Boolean, default: false },
  },
  computed: {
    otherGroup () { return this.resourceInteraction.getOtherGroup(this.forGroup.id) },
  },
  methods: {
    showEditResourceInteractionForm (resourceInteraction) {
      this.$emitBus('show-resource-interaction-form', { resourceInteraction, subjectId: null })
    },
    natureCSS (nature, position) {
      if (NATURES[nature][position] === true) return 'recording'
      if (NATURES[nature][position] === false) return 'destructive'

      return 'dim'
    },
  },
}
</script>
